/* $Id: 1$ */
/** @acpi.c
  *
  *  External funtion structure for ACPI
  *
  * netlabs.org confidential
  *
  * Copyright (c) 2006 netlabs.org
  *
  * Author: Pavel Shtemenko <pasha@paco.odessa.ua>
  *
  * All Rights Reserved
  *
  */
#ifndef __ACPIFUN_H__
#define __ACPIFUN_H__

#pragma pack(1)

typedef ACPI_STATUS (*ACPIEVALUATEOBJECT)(ACPI_NAMESPACE_NODE *PrefixNode,char *Path,UINT32 ExpectedReturnBtypes,ACPI_OPERAND_OBJECT **ReturnDesc);
typedef ACPI_STATUS (*ACPIWALKNAMESPACE )(ACPI_OBJECT_TYPE Type,ACPI_HANDLE StartObject,UINT32 MaxDepth,ACPI_WALK_CALLBACK UserFunction,void *Context,void **ReturnValue);
typedef ACPI_STATUS (*ACPIGETDEVICES    )(char *HID,ACPI_WALK_CALLBACK UserFunction,void *Context,void **ReturnValue);
typedef ACPI_STATUS (*ACPIGETNAME       )(ACPI_HANDLE Handle,UINT32 NameType,ACPI_BUFFER *RetPathPtr);
typedef ACPI_STATUS (*ACPIGETHANDLE     )(ACPI_HANDLE Parent,ACPI_STRING Pathname,ACPI_HANDLE *RetHandle);
typedef ACPI_STATUS (*ACPIGETOBJECTINFO )(ACPI_HANDLE Handle,ACPI_BUFFER *ReturnBuffer);
typedef const char *(*ACPIFORMATEXEPTION)(ACPI_STATUS Exception);
typedef int         (*ACPIUTMEMCMP      )(const char  *Buffer1,const char *Buffer2,ACPI_SIZE Count);


typedef struct _ACPI_FUNCTION_
               {
               PACPINotify        Device;                                // Device notify
               PACPINotify        System;                                // System notify
               ACPIEVALUATEOBJECT AcpiEvaluateObject;
               ACPIWALKNAMESPACE  AcpiWalkNamespace;
               ACPIGETDEVICES     AcpiGetDevices;
               ACPIGETNAME        AcpiGetName;
               ACPIGETHANDLE      AcpiGetHandle;
               ACPIGETOBJECTINFO  AcpiGetObjectInfo;
               ACPIFORMATEXEPTION AcpiFormatException;
               ACPIUTMEMCMP       AcpiUtMemcmp;
               } ACPIFUNCTION, *PACPIFUNCTION;

#pragma pack()

#endif