#pragma pack(1)

#define ADDRESS_SPACE_SYSTEM_MEMORY     0
#define ADDRESS_SPACE_SYSTEM_IO         1
#define ADDRESS_SPACE_SYSTEM_PCI        2
#define ADDRESS_SPACE_SYSTEM_CONTROLLER 3
#define ADDRESS_SPACE_SYSTEM_SMBUS      4
#define ADDRESS_SPACE_SYSTEM_HARDWARE   0x7F
#define ACCESS_SIZE_UNDEFINED           0
#define ACCESS_SIZE_BYTE                1
#define ACCESS_SIZE_WORD                2
#define ACCESS_SIZE_DWORD               3
#define ACCESS_SIZE_QWORD               4
typedef struct _GAS
               {
               unsigned char Address_Space_ID;
               unsigned char Register_Bit_Width;       /* Size in bits given register    */
               unsigned char Register_Bit_Offset;      /* Offset of the given register   */
               unsigned char Access_Size;
               unsigned long long Address;             /* 64 address of data or register */
               } GAS, *GASP;
typedef struct _DESCRIPTION_HEADER
               {
               unsigned char       Signature[4];       /* Signature                                   */
               unsigned long       Length;             /* Length of table                             */
               unsigned char       Revision;           /* Revision                                    */
               unsigned char       CheckSum;           /* Checksum                                    */
               unsigned char       OEMID[6];           /* OEM ID                                      */
               unsigned char       OEMTableID[8];      /* Particular OEM ID                           */
               unsigned long       OEMRevision;        /* OEM Revision                                */
               unsigned char       CreatorID[4];       /* Vendor ID of utility that created the table */
               unsigned long       CreatorRevision;    /* Revision of utility that created the table   */
               } DESCRIPTION_HEADER, *DESCRIPTION_HEADERP;
typedef struct _DESCRIPTION_HEADERX
               {
               DESCRIPTION_HEADER *Dev;
               unsigned long PhysAddressDHxHi;
               } DESCRIPTION_HEADERX, *DESCRIPTION_HEADERXP;
typedef struct _XSDT_
               {
               DESCRIPTION_HEADER  _XSDT;                /* Describe itself XSDT                        */
               DESCRIPTION_HEADERX DeviceXSDT[1];       /* Array  DH                                   */
               } XSDT,*XSDTP;

typedef struct _RSDT_
               {
               DESCRIPTION_HEADER  _RSDT;               /* Describe itself RSDT                        */
               DESCRIPTION_HEADER  *DeviceRSDT[1];      /* Array DH                                    */
               } RSDT,*RSDTP;
typedef struct _RSD 
               {
               unsigned char       SignatureRSD[8];    /* Signature            */
               unsigned char       CheckSumRSD;        /* Checksum ACPI 1.0    */
               unsigned char       OEMID_RSD[6];       /* OEM ID               */
               unsigned char       RevisionRSD;        /* Revison              */
               RSDTP               RsdtAddressPhys;    /* Address RSDT         */
               unsigned long       LengthRSD;          /* Length RSD           */
               XSDTP               XsdtAddress;        /* Address XSDT         */
               unsigned long       XsdtAddress64b;     /* 64bit extent of XSDT */
               unsigned char       ExtendedCheckSum;   /* Checksum ACPI 2.0    */
               unsigned char       ReservedRSD[3];
               } RSD, *RSDP;
typedef  struct _FADT_
               {
DESCRIPTION_HEADER  _FADT;           /* Describe itself XSDT                        */
unsigned long FIRMWARE_CTRL;         /* Physical memory address (0-4 GB) of the FACS, where OSPM and Firmware
                                        exchange control information. See section 5.2.6, "RootSystem Description Table,"
                                        for a description of the FACS. */
unsigned long DSDT;                  /* Physical memory address (0-4 GB) of the DSDT. */
unsigned char ReservedFAC;           /* ACPI 1.0 defined this offset as a field named INT_MODEL, which was eliminated in
                                        ACPI 2.0. Platforms should set this field to zero but field values of one are also
                                        allowed to maintain compatibility with ACPI 1.0. */
unsigned char Preferred_PM_Profile;  /* This field is set by the OEM to convey the preferred power management profile to
                                        OSPM. OSPM can use this field to set default power management policy parameters
                                        during OS installation.
                                          Field Values:
                                             0 Unspecified
                                             1 Desktop
                                             2 Mobile
                                             3 Workstation
                                             4 Enterprise Server
                                             5 SOHO Server
                                             6 Appliance PC
                                             7 Performance Server
                                             >7 Reserved
                                      */
unsigned short SCI_INT;               /* System vector the SCI interrupt is wired to in 8259 mode. On systems that do not
                                         contain the 8259, this field contains the Global System interrupt number of the
                                         SCI interrupt. OSPM is required to treat the ACPI SCI interrupt as a sharable, level,
                                         active low interrupt. */
unsigned long SMI_CMD;                /* System port address of the SMI Command Port. During ACPI OS initialization, OSPM can
                                         determine that the ACPI hardware registers are owned by SMI (by way of the SCI_EN bit),
                                         in which case the ACPI OS issues the ACPI_ENABLE command to the SMI_CMD port. The 
                                         SCI_EN bit effectively tracks the ownership of the ACPI hardware registers. OSPM 
                                         issues commands to the SMI_CMD port synchronously from the boot processor. This field
                                         is reserved and must be zero on system that does not support System Management mode.
                                       */
unsigned char ACPI_ENABLE;            /* The value to write to SMI_CMD to disable SMI ownership of the ACPI hardware registers.
                                         The last action SMI does to relinquish ownership is to set the SCI_EN bit. During the
                                         OS initialization process, OSPM will synchronously wait for the transfer of SMI ownership
                                         to complete, so the ACPI system releases SMI ownership as quickly as possible. This field
                                         is reserved and must be zero on systems that do not support Legacy Mode. */
unsigned char ACPI_DISABLE;            /* The value to write to SMI_CMD to re-enable SMI ownership of the ACPI hardware registers.
                                          This can only be done when ownership was originally acquired from SMI by OSPM using 
                                          ACPI_ENABLE. An OS can hand ownership back to SMI by relinquishing use to the ACPI
                                          hardware registers, masking off all SCI interrupts, clearing the SCI_EN bit and then
                                          writing ACPI_DISABLE to the SMI_CMD port from the boot processor. This field is reserved
                                          and must be zero on systems that do not support Legacy Mode. */
unsigned char S4BIOS_REQ;              /* The value to write to SMI_CMD to enter the S4BIOS state. The S4BIOS state provides an 
                                          alternate way to enter the S4 state where the firmware saves and restores the memory
                                          context. A value of zero in S4BIOS_F indicates S4BIOS_REQ is not supported. */
unsigned char PSTATE_CNT;              /* If non-zero, this field contains the value OSPM writes to the SMI_CMD register to assume
                                          processor performance state control responsibility. */
unsigned long PM1a_EVT_BLK;            /* System port address of the PM1a Event Register Block. This is a required field. This field 
                                          is superseded by the X_PM1a_EVT_BLK field. */
unsigned long PM1b_EVT_BLK;            /* System port address of the PM1b Event Register Block. This field is optional; if this
                                          register block is not supported, this field contains zero. This field is superseded by
                                          the X_PM1b_EVT_BLK field. */
unsigned long PM1a_CNT_BLK;            /* System port address of the PM1a Control Register Block. This is a required field. This
                                          field is superseded by the X_PM1a_CNT_BLK field. */
unsigned long PM1b_CNT_BLK;            /* System port address of the PM1b Control Register Block. This field is optional; if this
                                          register block is not supported, this field contains zero. This field is superseded by 
                                          the X_PM1b_CNT_BLK field. */
unsigned long PM2_CNT_BLK;              /* System port address of the PM2 Control Register Block. This field is optional; if this
                                           register block is not supported, this field contains zero. This field is superseded by
                                           the X_PM2_CNT_BLK field. */
unsigned long PM_TMR_BLK;                /* System port address of the Power Management Timer Control Register Block. This is a
                                            required field. This field is superseded by the X_PM_TMR_BLK field. */
unsigned long GPE0_BLK;                  /* System port address of General-Purpose Event 0 Register Block. This is an optional 
                                            field; if this register block is not supported, this field contains zero. This field 
                                            is superseded by the X_GPE0_BLK field. */
unsigned long GPE1_BLK;                  /* System port address of General-Purpose Event 1 Register Block. This is an optional
                                            field; if this register block is not supported, this field contains zero. This field
                                            is superseded by the X_GPE1_BLK field. */
unsigned char PM1_EVT_LEN;               /* Number of bytes decoded by PM1a_EVT_BLK and, if supported, PM1b_ EVT_BLK. This 
                                            value is >= 4. */
unsigned char PM1_CNT_LEN;               /* Number of bytes decoded by PM1a_CNT_BLK and, if supported, PM1b_CNT_BLK. This value
                                            is >=2. */
unsigned char PM2_CNT_LEN;               /* Number of bytes decoded by PM2_CNT_BLK. Support for the PM2 register block is optional.
                                            If supported, this value is >= 1. If not supported, this field contains zero. */
unsigned char PM_TMR_LEN;                /* Number of bytes decoded by PM_TMR_BLK. This field's value must be 4. */
unsigned char GPE0_BLK_LEN;              /*  Number of bytes decoded by GPE0_BLK. The value is a non-negative multiple of 2. */
unsigned char GPE1_BLK_LEN;              /* Number of bytes decoded by GPE1_BLK. The value is a non-negative multiple of 2. */
unsigned char GPE1_BASE;                 /* Offset within the ACPI general-purpose event model where GPE1 based events start. */
unsigned char CST_CNT;                   /* If non-zero, this field contains the value OSPM writes to the SMI_CMD register to
                                            indicate OS support for the _CST object and C States Changed notification. */
unsigned short P_LVL2_LAT;               /* The worst-case hardware latency, in microseconds, to enter and exit a C2 state. A 
                                            value > 100 indicates the system does not support a C2 state. */
unsigned short P_LVL3_LAT;               /* The worst-case hardware latency, in microseconds, to enter and exit a C3 state. A
                                            value > 1000 indicates the system does not support a C3 state. */
unsigned short FLUSH_SIZE;               /* If WBINVD=0, the value of this field is the number of flush strides that need to be
                                            read (using cacheable addresses) to completely flush dirty lines from any processor's
                                            memory caches. Notice that the value in FLUSH_STRIDE is typically the smallest cache
                                            line width on any of the processor's caches (for more information, see the FLUSH_STRIDE
                                            field definition). If the system does not support a method for flushing the processor's
                                            caches, then FLUSH_SIZE and WBINVD are set to zero. Notice that this method of flushing
                                            the processor caches has limitations, and WBINVD=1 is the preferred way to flush the
                                            processors caches. This value is typically at least 2 times the cache size. The maximum
                                            allowed value for FLUSH_SIZE multiplied by FLUSH_STRIDE is 2 MB for a typical maximum 
                                            supported cache size of 1 MB. Larger cache sizes are supported using WBINVD=1. This
                                            value is ignored if WBINVD=1. This field is maintained for ACPI 1.0 processor
                                            compatibility on existing systems. Processors in new ACPI-compatible systems are
                                            required to support the WBINVD function and indicate this to OSPM by setting the
                                            WBINVD field = 1.
                                            */
unsigned short FLUSH_STRIDE;              /* If WBINVD=0, the value of this field is the cache line width, in bytes, of the
                                             processor's memory caches. This value is typically the smallest cache line width on
                                             any of the processor's caches. For more information, see the description of the
                                             FLUSH_SIZE field. This value is ignored if WBINVD=1. This field is maintained for
                                             ACPI 1.0 processor compatibility on existing systems. Processors in new 
                                             ACPI-compatible systems are required to support the WBINVD function and indicate
                                             this to OSPM by setting the WBINVD field = 1. */
unsigned char DUTY_OFFSET;                 /* The zero-based index of where the processor's duty cycle setting is within the
                                              processor's P_CNT register. */
unsigned char DUTY_WIDTH;                  /* The bit width of the processor's duty cycle setting value in the P_CNT register. Each processor's duty cycle setting allows the
                                              software to select a nominal processor frequency below its absolute
                                              frequency as defined by:
                                                  THTL_EN = 1
                                                  BF * DC/(2 DUTY_WIDTH )
                                               Where:
                                                  BF-Base frequency
                                                  DC-Duty cycle setting
                                               When THTL_EN is 0, the processor runs at its absolute BF. A DUTY_WIDTH value of 0
                                               indicates that processor duty cycle is not supported and the processor continuously
                                               runs at its base frequency.  */
unsigned char DAY_ALRM;                     /* The RTC CMOS RAM index to the day-of-month alarm value. If this field contains a zero,
                                               then the RTC day of the month alarm feature is not supported. If this field has a
                                               non-zero value, then this field contains an index into RTC RAM space that OSPM can
                                               use to program the day of the month alarm. */
unsigned char MON_ALRM;                     /* The RTC CMOS RAM index to the month of year alarm value. If this field contains a
                                               zero, then the RTC month of the year alarm feature is not supported. If this field 
                                               has a non-zero value, then this field contains an index into RTC RAM space that OSPM
                                               can use to program the month of the year alarm. If this feature is supported, then
                                               the DAY_ALRM feature must be supported also. */
unsigned char CENTURY;                      /* The RTC CMOS RAM index to the century of data value (hundred and thousand year
                                               decimals). If this field contains a zero, then the RTC centenary feature is not
                                               supported. If this field has a non-zero value, then this field contains an index
                                               into RTC RAM space that OSPM can use to program the centenary field. */
unsigned short IAPC_BOOT_ARCH;              /*  IA-PC Boot Architecture Flags. */
unsigned char Rsrvd2;                       /*  Must be 0. */
unsigned long Flags;                        /*  Fixed feature flags. */
GAS           RESET_REG;                    /* The address of the reset register represented in Generic Address. Note: Only System
                                               I/O space, System Memory space and PCI Configuration space (bus #0) are valid for
                                               values for Address_Space_ID. Also, Register_Bit_Width must be 8 and
                                               Register_Bit_Offset must be 0. */
unsigned char RESET_VALUE;                  /* Indicates the value to write to the RESET_REG port to reset the system. */
unsigned char Rsrvd3[3];                    /* Must be 0. */
unsigned long long X_FIRMWARE_CTRL;         /* 64bit physical address of the FACS. */
unsigned long long X_DSDT;                  /* 64bit physical address of the DSDT. */
unsigned long X_PM1a_EVT_BLK[3];            /* Extended address of the PM1a Event Register Block, represented in Generic Address 
                                               Structure format. This is a required field. */
unsigned long X_PM1b_EVT_BLK[3];            /* Extended address of the PM1b Event Register Block, represented in Generic Address
                                               Structure format. This field is optional; if this register block is not supported,
                                               this field contains zero. */
unsigned long X_PM1a_CNT_BLK[3];            /* Extended address of the PM1a Control Register Block, This is a required field. */
unsigned long X_PM1b_CNT_BLK[3];            /* Extended address of the PM1b Control Register Block, This field is optional; if this register block is not
                                               supported, this field contains zero. */
unsigned long X_PM2_CNT_BLK[3];             /*  Extended address of the Power Management 2 Control Register Block, This field is
                                                optional; if this register block is not supported, this field contains zero. */
unsigned long X_PM_TMR_BLK[3];              /*  Extended address of the Power Management Timer Control Register Block. This is a
                                                required field. */
unsigned long X_GPE0_BLK[3];                /* Extended address of the General-Purpose Event 0 Register Block, This is an optional
                                               field; if this register block is not supported, this field contains zero. */
unsigned long X_GPE1_BLK[3];                /* Extended address of the General-Purpose Event 1 Register Block. This is an optional
                                               field; if this register block is not supported, this field contains zero. */
} FADT, *FADTP;

#define Flags_WBINVD       1                /* Processor properly implements a functional equivalent to the  WBINVD IA-32
                                               instruction. If set, signifies that the WBINVD instruction correctly flushes the
                                               processor caches, maintains memory coherency, and upon completion of the instruction,
                                               all caches for the current processor contain no cached data other than what OSPM
                                               references and allows to be cached. If this flag is not set, the ACPI OS is
                                               responsible for disabling all ACPI features that need this function. This field is
                                               maintained for ACPI 1.0 processor compatibility on existing systems. Processors in
                                               new ACPI-compatible systems are required to support this function and indicate this
                                               to OSPM by setting this field. */
#define Flags_WBINVD_FLUSH 2                /* If set, indicates that the hardware flushes all caches on the WBINVD instruction and
                                               maintains memory coherency, but does not guarantee the caches are invalidated. This
                                               provides the complete semantics of the WBINVD instruction, and provides enough to
                                               support the system sleeping states. If neither of the WBINVD flags is set, the
                                               system will require FLUSH_SIZE and FLUSH_STRIDE to support sleeping states. If the
                                               FLUSH parameters are also not supported, the machine cannot support sleeping states
                                               S1, S2, or S3. */
#define Flags_PROC_C1      4                /* A one indicates that the C1 power state is supported on all processors. */
#define Flags_P_LVL2_UP    8                /* A zero indicates that the C2 power state is configured to only work on a
                                               uniprocessor (UP) system. A one indicates that the C2 power state is configured to
                                               work on a UP or multiprocessor (MP) system. */
#define Flags_PWR_BUTTON   0x10             /* A zero indicates the power button is handled as a fixed feature programming model; a one indicates the power button is handled
                                               as a control method device. If the system does not have a power button, this value
                                               would be "1" and no sleep button device would be present. Independent of the value
                                               of this field, the presence of a power button device in the namespace indicates to
                                               OSPM that the power button is handled as a control method device.
                                             */
#define Flags_SLP_BUTTON   0x20              /* A zero indicates the sleep button is handled as a fixed feature programming model;
                                                a one indicates the sleep button is handled as a control method device. If the
                                                system does not have a sleep button, this value would be "1" and no sleep button
                                                device would be present. Independent of the value of this field, the presence of
                                                a sleep button device in the namespace indicates to OSPM that the sleep button is
                                                handled as a control method device. */
#define Flags_FIX_RTC      0x40               /* A zero indicates the RTC wake status is supported in fixed register space; a one
                                                 indicates the RTC wake status is not supported in fixed register space. */
#define Flags_RTC_S4       0x80               /* Indicates whether the RTC alarm function can wake the system from the S4 state.
                                                 The RTC must be able to wake the system from an S1, S2, or S3 sleep state. The
                                                 RTC alarm can optionally support waking the system from the S4 state, as indicated
                                                 by this value. */
#define Flags_TMR_VAL_EXT  0x100              /* A zero indicates TMR_VAL is implemented as a 24-bit value. A one indicates TMR_VAL
                                                 is implemented as a 32-bit value. The TMR_STS bit is set when the most significant
                                                 bit of the TMR_VAL toggles. */
#define Flags_DCK_CAP      0x200              /* A zero indicates that the system cannot support docking. A one indicates that the
                                                 system can support docking. Notice that this flag does not indicate whether or not
                                                 a docking station is currently present; it only indicates that the system is
                                                 capable of docking. */
#define Flags_RESET_REG_SUP 0x400             /* If set, indicates the system supports system reset via the FADT RESET_REG If set
                                                 indicates that the system has no internal expansion capabilities and the case is
                                                 sealed. */
#define Flags_SEALED_CASE   0x800             /* System Type Attribute. If set indicates  */
#define Flags_HEADLESS      0x1000            /* System Type Attribute. If set indicates the system cannot detect the monitor or
                                                 keyboard / mouse devices. */
#define Flags_CPU_SW_SLP    0x2000            /* If set, indicates to OSPM that a processor native instruction must be executed
                                                 after writing the SLP_TYPx register. */
#define Flags_PCI_EXP_WAK   0x4000            /* If set, indicates the platform supports the PCIEXP_WAKE_STS bit in the PM1 Status
                                                 register and the PCIEXP_WAKE_EN bit in the PM1 Enable register. */
#define Flags_USE_PLATFORM_CLOCK 0x8000       /* A value of one indicates that OSPM should use a platform provided timer to drive
                                                 any monotonically non-decreasing counters, such as OSPM performance counter
                                                 services. Which particular platform timer will be used is OSPM specific, however,
                                                 it is recommended that the timer used is based on the following algorithm: If the
                                                 HPET is exposed to OSPM, OSPM should use the HPET. Otherwise, OSPM will use the
                                                 ACPI power management timer. A value of one indicates that the platform is known
                                                 to have a correctly implemented ACPI power management timer. A platform may choose
                                                 to set this flag if a internal processor clock (or clocks in a multi-processor
                                                 configuration) cannot provide consistent monotonically non-decreasing counters.
                                                 Note: If a value of zero is present, OSPM may arbitrarily choose to use an 
                                                 internal processor clock or a platform timer clock for these operations. That is,
                                                 a zero does not imply that OSPM will necessarily use the internal processor clock
                                                 to generate a monotonically non-decreasing counter to the system. */
#define Flags_S4_RTC_STS_VALID 0x10000        /* A one indicates that the contents of the RTC_STS flag is valid when waking the
                                                 system from S4. Some existing systems do not reliably set this input today, and
                                                 this bit allows OSPM to differentiate correctly functioning platforms from
                                                 platforms with this errata. */
#define Flags_REMOTE_POWER_ON_CAPABLE 0x20000 /* A one indicates that the platform is compatible with remote power on. That is, the
                                                 platform supports OSPM leaving GPE wake events armed prior to an S5 transition.
                                                 Some existing platforms do not reliably transition to S5 with wake events enabled
                                                 (for example, the platform may immediately generate a spurious wake event after
                                                 completing the S5 transition). This flag allows OSPM to differentiate correctly
                                                 functioning platforms from platforms with this type of errata. */
#define Flags_FORCE_APIC_CLUSTER_MODEL 0x40000 /* A one indicates that all local APICs must be configured for the cluster
                                                  destination model when delivering interrupts in logical mode. If this bit is
                                                  set, then logical mode interrupt delivery operation may be undefined until OSPM
                                                  has moved all local APICs to the cluster model.
                                                  Note that the cluster destination model doesn't apply to Itanium processor local
                                                  SAPICs. This bit is intended for xAPIC based machines that require the cluster
                                                  destination model even when 8 or fewer local APICs are present in the machine.
                                                  */
#define Flags_FORCE_APIC_PHYSICAL_DESTINATION_MODE 0x80000 /* A one indicates that all local xAPICs must be configured for physical
                                                              destination mode. If this bit is set, interrupt delivery operation in
                                                              logical destination mode is undefined. On machines that contain fewer
                                                              than 8 local xAPICs or that do not use the xAPIC architecture, this
                                                               bit is ignored. */

#pragma pack()

#ifndef ACPI_ASL_COMPILER

ULONG FindTable(RSDTP,char *);                 // 饬 FACDT
void _cdecl printf (char *, ...);
void MyInitDebug(void);
void PrintRSDT(RSDTP);
void PrintXSDT(XSDTP);
void PrintRSD(RSDP);
void PrintfDH(DESCRIPTION_HEADERP);
void  PrintfFACDT(ULONG);
void PrintBuf(char *,unsigned int);
void  PrintTable(ULONG);

extern ULONG                  IOAPICCount;                        // IO APIC count
extern PIOAPIC                MADTioAPIC;                           // Pointer to IO APIC
extern ULONG                  CPUidToNumber[];
extern PPROCESSOR Processor;
extern PAcpiIRQ   CurrentIRQ;
extern PAcpiIRQ   PossibleIRQ;
extern PAcpiIRQ   OverrideIRQ;
extern PIRQBus    SetIRQBus;

extern ULONG PowerButtonFlag;                                     // For KernWakeUp
extern ULONG SleepButtonFlag;                                     // For KernWakeUp
extern ULONG PowerButtonStatus;                                   // Status install handler
extern ULONG SleepButtonStatus;                                   // Status install handler
extern ULONG DeviceNotifyFlag;
extern ULONG SystemNotifyFlag;
extern ULONG DeviceNotifyStatus;
extern ULONG SystemNotifyStatus;

#define MAX_CPU               64
#define MAX_BUS_COUNT         256
#define MAX_IOAPIC            16


#define _64K      (64 * 1024)
#define BIOS_SEG             0xE000
#define AFFINITY_CPU_ENABLE                  1     // Flags
typedef struct affinity_processor
{
     UINT8         Type;                         // 0 - Processor
     UINT8         Length;                       // 16 bytes
     UINT8         ProximityDomain0_7;
     UINT8         LocalAPICId;
     UINT32        Flags;                         // Flags, 0 - disable, 1 - enable this struct
     UINT8         LocalSAPICEid;
     UINT8         ProximityDomain8_32[3];
     UINT32        Reserved;
} AFF_CPU;
#define AFFINITY_MEMORY_ENABLE                  1     // Flags
#define AFFINITY_MEMORY_HOTPLUG                 2     // 
#define AFFINITY_MEMORY_NONVOLATILE             4     // 
//
#define AFFINITY_TYPE_PROCESSOR               0     // 
#define AFFINITY_TYPE_MEMORY                  1     // 

typedef struct affinity_memory
{
     UINT8         Type;                         // 1 - Memory
     UINT8         Length;                       // 40 bytes
     UINT32        ProximityDomain;
     UINT16        Reserved;
     UINT64        AddressBase;
     UINT64        AddressLength;
     UINT32        Reserved2;
     UINT32        Flags;                         // Flags, 0 - disable, 1 - enable this struct
     UINT64        Reserved3;
          
} AFF_MEMORY;
typedef struct affinity_common
{
     UINT8         Type;                         //
     UINT8         Length;                       //
} AFF_COMMON;
typedef union affinity
{
     AFF_CPU      Processor;
     AFF_MEMORY   Memory;
     AFF_COMMON   Common;
} AFFINITY, *PAFFINITY;
/* SRAT */

typedef struct system_resources_affinity
{
    ACPI_TABLE_HEADER_DEF                           /* ACPI common table header */
    UINT32                  Reserved1;
    UINT64                  Reserved;
    AFFINITY                Affinity;

} RESOURCE_AFFINITY_TABLE;

union  UINT8to32
       {
       UINT8     Res8[4];
       UINT32    Res32;
       };

#endif
