/*
** BIOS Parameter Block
*/
#pragma pack(1)

typedef struct _BPB  {                  /* BPB */

  USHORT        BytesPerSector;
  UCHAR         SectorsPerCluster;
  USHORT        ReservedSectors;
  UCHAR         NumFATs;
  USHORT        MaxDirEntries;
  USHORT        TotalSectors;
  UCHAR         MediaType;
  USHORT        NumFATSectors;
  USHORT        SectorsPerTrack;
  USHORT        NumHeads;
  ULONG         HiddenSectors;
  ULONG         BigTotalSectors;
  UCHAR         Reserved_1[6];
} BPB, *PBPB, *NPBPB;

typedef BPB     *BPBS[];         /* An array of NEAR BPB Pointers */
typedef BPBS    *PBPBS;          /* A pointer to the above array  */

typedef struct aa
     {
     UCHAR  Command;			/* Identify Volume Type */
     UCHAR  DriveUnit;
     USHORT TableNumber;
     ULONG  LSN;
     } DDI_OS2LVM_param ;
typedef struct bb
    {
    UCHAR ReturnData;
    void *UserBuffer; 
    } DDI_OS2LVM_data ;
typedef struct _BadBlockInf
    {
    ULONG TotalRelocations;
    ULONG TotalTables;
    } BadBlockInfo;
typedef struct _BadBlackInf
    {
    ULONG ActiveRelocations;
    ULONG MaxRelocationsAllowed;
    } BadBlockTableInfo;
#define ENABLE_BBR 1
#define DISABLE_BBR 2
#define GET_BBR_INFO 3
#define BBR_SUCCESS 1 /* ???? */
#define GET_TBL_SIZE 4
#define GET_SECT_LIST 5
#define REMOVE_TBL_ENTRY 7
#define CLEAR_TBL 8

#pragma pack()
