/***************************************************************************
 *      Created 2005  eCo Software                                         *
 *                                                                         *
 *      DISCLAIMER OF WARRANTIES.  The following [enclosed] code is        *
 *      sample code created by eCo Software. This sample code is not part  *
 *      of any standard or eCo Software product and is provided to you     *
 *      solely for the purpose of assisting you in the development of your *
 *      applications.  The code is provided "AS IS", without               *
 *      warranty of any kind. eCo Software shall not be liable for any     *
 *      damages arising out of your use of the sample code, even if they   *
 *      have been advised of the possibility of such damages.              *
 *-------------------------------------------------------------------------*/
#include <os2.h>
#include <acpi.h>
#include <acpiapi.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void AcpiWalkNameSpaceTst(void);
unsigned char *AcpiStatusToStr(ACPI_STATUS);

UINT32       PowerUnit = 2;
char         *PowerString[] = { "mW","mA","Unknown"};

UINT32 BRate=0;
UINT32 BRemaining=0;
UINT32 LastFull=0;
/*
 *  Show ACPI tree with resource
 *  Pavel Shtemenko 14.08.2005
 */
ACPI_OBJECT       Object[20];

void PrintBST(ACPI_HANDLE ObjHandle)
{
ACPI_OBJECT  *Obj;
ACPI_BUFFER  Results;
UINT32       PowerUnit;
ACPI_STATUS  Status;

  Results.Length  = sizeof(Object);
  Results.Pointer = Object;

Status=AcpiEvaluateObject(ObjHandle,"_BST",NULL,&Results);
if( Status != AE_OK )
 {
 printf("Error evaluate _BST, status %x\n",Status);
 return;
 }

// PrintBuf((char *)&Results,Results.Length);

 printf("=========== Battery Status ===============\n");
 Obj=(ACPI_OBJECT *)Object[0].Package.Elements;

 if( (UINT32)Obj[0].Integer.Value & 1 ) printf("Buttery is discharging\n");
 if( (UINT32)Obj[0].Integer.Value & 2 ) printf("Buttery is charging\n");
 if( (UINT32)Obj[0].Integer.Value & 4 ) printf("Buttery is low critical energy state\n");

 if(Obj[1].Integer.Value != 0xffffffff)
   {
   if(!BRate)
      BRate = (UINT32)Obj[1].Integer.Value;
   printf("%d Battery present rate %d\n",Obj[1].Type,(UINT32)Obj[1].Integer.Value);
   }
 else
   printf("Unknown battery present rate\n");

 if(Obj[2].Integer.Value != 0xffffffff)
   {
   if(!BRemaining)
      BRemaining = (UINT32)Obj[2].Integer.Value;
   printf("%d Battery remaining capacity %d\n",Obj[2].Type,(UINT32)Obj[2].Integer.Value);
   }
 else
   printf("Unknown battery remaining capacity\n");

 if(Obj[3].Integer.Value != 0xffffffff)
   printf("%d Battery present voltage %d mV \n",Obj[3].Type,(UINT32)Obj[3].Integer.Value);
 else
   printf("Unknown battery remaining capacity\n");


}
void PrintBIF(ACPI_HANDLE ObjHandle)
{
ACPI_OBJECT  *Obj;
ACPI_BUFFER  Results;
ACPI_STATUS  Status;
UINT32       i;

  Results.Length  = sizeof(Object);
  Results.Pointer = Object;

Status=AcpiEvaluateObject(ObjHandle,"_BIF",NULL,&Results);
if(Status != AE_OK)
 {
 printf("Error evaluate _BIF, status %x\n",Status);
 return;
 }

// PrintBuf((char *)&Results,Results.Length);
 printf("=========== Battery design ===============\n");
 Obj=(ACPI_OBJECT *)Object[0].Package.Elements;


 PowerUnit = (UINT32)Obj[0].Integer.Value;
 printf("Power Unit: capacity is %s , charge/discharge rate is %s\n",PowerString[PowerUnit],PowerString[PowerUnit]);
 if((UINT32)Obj[1].Integer.Value != 0xffffffff )
   printf("%d Design capacity %d %s\n",Obj[1].Type,(UINT32)Obj[1].Integer.Value,PowerString[PowerUnit]);
 else
  printf("Unknown design capacity\n");

 if((UINT32)Obj[2].Integer.Value != 0xffffffff)
   {
   if( !LastFull )
      LastFull = (UINT32)Obj[2].Integer.Value;
   printf("%d Last full charge capacity %d %s\n",Obj[2].Type,(UINT32)Obj[2].Integer.Value, PowerString[PowerUnit]);
   }
 else
  printf("Unknown last full charge capacity\n");

 printf("%d Battery technology %x\n",Obj[3].Type,(UINT32)Obj[3].Integer.Value);

 if((UINT32)Obj[4].Integer.Value != 0xffffffff)
   printf("%d Design voltage %d mV\n",Obj[4].Type,(UINT32)Obj[4].Integer.Value);
 else
  printf("Unknown design voltage\n");

 if((UINT32)Obj[5].Integer.Value != 0xffffffff)
   printf("%d Design capacity of warning %d %s\n",Obj[5].Type,(UINT32)Obj[5].Integer.Value,PowerString[PowerUnit]);
 else
  printf("Unknown design capacity of warning\n");

 if((UINT32)Obj[6].Integer.Value != 0xffffffff)
   printf("%d Design capacity of low %d %s\n",Obj[6].Type,(UINT32)Obj[6].Integer.Value,PowerString[PowerUnit]);
 else
  printf("Unknown design capacity of low\n");

 if((UINT32)Obj[7].Integer.Value != 0xffffffff)
   printf("%d Baterry granularity between low and warning %u %s\n",Obj[7].Type,(UINT32)Obj[7].Integer.Value,PowerString[PowerUnit]);
 else
  printf("Unknown Baterry granularity between low and warning\n");

 if((UINT32)Obj[8].Integer.Value != 0xffffffff)
   printf("%d Baterry granularity between warning and high %u %sh\n",Obj[8].Type,(UINT32)Obj[8].Integer.Value,PowerString[PowerUnit]);
 else
  printf("Unknown Baterry granularity between warning and high\n");

 if(Obj[9].Buffer.Pointer)
  {
  printf("%d ModelNumber: \"%s\" %d bytes \"",Obj[9].Type,Obj[9].Buffer.Pointer,Obj[9].Buffer.Length);
  for (i = 0; i < Obj[9].Buffer.Length; i++)
      printf("%2.2x",Obj[9].Buffer.Pointer[i]);
  printf("\"\n");
  }
 if(Obj[10].Buffer.Pointer)
  printf("%d SerialNumber: \"%s\" %d bytes %x\n",Obj[10].Type,Obj[10].Buffer.Pointer,Obj[10].Buffer.Length,Obj[10].Buffer.Pointer[0]);
 if(Obj[11].Buffer.Pointer)
  printf("%d Battery type: \"%s\"%d bytes\n",Obj[11].Type,Obj[11].Buffer.Pointer,Obj[11].Buffer.Length);
 if(Obj[12].Buffer.Pointer)
  printf("%d OEM info: \"%s\" %d\n",Obj[12].Type,Obj[12].Buffer.Pointer,Obj[12].Buffer.Length);


}

/*
 * CallBack function for print object info and walk resource info
 */
ACPI_STATUS internal_PrintObjectInfo(ACPI_HANDLE ObjHandle,
				     UINT32 NestingLevel,
				     void *Context,
				     void **ReturnValue)
{
  int i;
  ACPI_BUFFER Buffer;
  ACPI_DEVICE_INFO DevInfo;
  char achName[5];
  ACPI_BUFFER       Results;
  ACPI_OBJECT       Obj,*oObj;
  ACPI_STATUS       Status;
  ULONG Lev;
  double Life;

  Results.Length  = sizeof(Object);
  Results.Pointer = &Object;


  Buffer.Length = sizeof(DevInfo);
  Buffer.Pointer = &DevInfo;
  AcpiGetObjectInfo(ObjHandle,&Buffer);
// printf("%s\n",achName);
  if (DevInfo.Valid & ACPI_VALID_HID)
     {
     if( strncmp ( (char *)&DevInfo.HardwareId,"PNP0C0A",8) == 0 )
       {
        memset(achName, 0, 5);
        Buffer.Length = 5;
        Buffer.Pointer = achName;
        AcpiGetName(ObjHandle, ACPI_SINGLE_NAME, &Buffer);
        printf("Found Smart Battery \"%s\"\n",achName);
        PrintBIF(ObjHandle);
        PrintBST(ObjHandle);
        if( BRate && BRemaining)
          {
           Life = (double)BRemaining / (double)BRate;
           printf("Remaining Battery Life: %lf h \n", Life );
          }
        if( LastFull && BRemaining)
          {
          printf("Remaining Battery Percentage: %d\n",  (BRemaining * 100) / LastFull );
          }
       }
     }

  return AE_OK;
}
/*
 * Main programm for walk ACPI tree
*/
void main(void)
{
 ACPI_STATUS       Status;
 ULONG Lev;


  printf("Show ACPI battery state\n");
  Status=AcpiWalkNamespace(ACPI_TYPE_ANY, // All object types
		             ACPI_ROOT_OBJECT, // Start object
		             ACPI_UINT32_MAX, // Max depth
		             internal_PrintObjectInfo,  // Callback
                           &Lev, NULL);  // Callback param and poitner to return value
 printf("Status 0x%x %d - %s\n",Status,Status,AcpiStatusToStr(Status));
}