/***************************************************************************
 *      Created 2005  eCo Software                                         *
 *                                                                         *
 *      DISCLAIMER OF WARRANTIES.  The following [enclosed] code is        *
 *      sample code created by eCo Software. This sample code is not part  *
 *      of any standard or eCo Software product and is provided to you     *
 *      solely for the purpose of assisting you in the development of your *
 *      applications.  The code is provided "AS IS", without               *
 *      warranty of any kind. eCo Software shall not be liable for any     *
 *      damages arising out of your use of the sample code, even if they   *
 *      have been advised of the possibility of such damages.              *
 *-------------------------------------------------------------------------*/
#define INCL_DOSPROCESS
#include <os2.h>
#include "acpi.h"
#include "acpiapi.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"

#define MICROSECONS_IN_DAY   ((UINT64)24*(UINT64)60*(UINT64)60*(UINT64)1000*(UINT64)1000)
#define MICROSECONS_IN_HOUR  ((UINT64)60*(UINT64)60*(UINT64)1000*(UINT64)1000)
#define MICROSECONS_IN_MIN   ((UINT64)60*(UINT64)1000*(UINT64)1000)
#define MICROSECONS_IN_SEC   ((UINT64)1000*(UINT64)1000)

void main(void)
{

ACPI_STATUS Status;
UINT32 Ticks,Resolution;
UINT64 Calls,TimesInCall,TimeAll;
APIRET rc;
ACPI_API_HANDLE Hdl;
UINT64 Day,Hour,Min,Sec,Msec,MkSec;

 rc=AcpiStartApi(&Hdl);
 if(rc)
   {
   printf("Error open ACPI rc=%d\n",rc);
   return;
   }
 Status=AcpiGetTimerResolution(&Resolution);
 if( Status != AE_OK)
   {
   printf("AcpiGetTimerResolution Status=%x\n",Status);
   return;
   }
 rc=AcpiGetUpTime(&Hdl,&Calls,&Ticks);

 TimeAll =( ( ((Calls << ((UINT8) Resolution-1)) + Ticks )  ) * (UINT64)1000000) / (UINT64)PM_TIMER_FREQUENCY;
 Day  = TimeAll / MICROSECONS_IN_DAY;
 Hour = (TimeAll - Day * MICROSECONS_IN_DAY)/MICROSECONS_IN_HOUR;
 Min  = (TimeAll - Day * MICROSECONS_IN_DAY - Hour * MICROSECONS_IN_HOUR)/MICROSECONS_IN_MIN;
 Sec  = (TimeAll - Day * MICROSECONS_IN_DAY - Hour * MICROSECONS_IN_HOUR - Min * MICROSECONS_IN_MIN)/MICROSECONS_IN_SEC;
 printf("%lld days %lld hours %lld minutes %lld sec\n",
        Day,Hour,Min,Sec);
 AcpiEndApi(&Hdl);
}
