/***************************************************************************
 *      Created 2005  eCo Software                                         *
 *                                                                         *
 *      DISCLAIMER OF WARRANTIES.  The following [enclosed] code is        *
 *      sample code created by eCo Software. This sample code is not part  *
 *      of any standard or eCo Software product and is provided to you     *
 *      solely for the purpose of assisting you in the development of your *
 *      applications.  The code is provided "AS IS", without               *
 *      warranty of any kind. eCo Software shall not be liable for any     *
 *      damages arising out of your use of the sample code, even if they   *
 *      have been advised of the possibility of such damages.              *
 *-------------------------------------------------------------------------*/
#include <os2.h>
#include <acpi.h>
#include <acpiapi.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
void main(void)
{
 APIRET rc;
 ACPI_API_HANDLE Hdl;
 ACPI_STATISTICS Stat;
 PAcpiIRQ IRQ;
 ULONG i,Num;
 
   rc=AcpiStartApi(&Hdl);
   if(rc)
     {
     printf("Error open ACPI API rc=%d - 0x%x\n",rc,rc);
     exit(1);
     }
   Stat.Command = ACPI_STATISTICS_GETSIZEIRQ;
   rc=AcpiGetStatistics(&Hdl,&Stat);
   if(rc)
     {
     printf("Error open Stat rc=%d - %x\n",rc,rc);
     exit(1);
     }
   Num=Stat.Number;
   printf("Use %d IRQs\n",Stat.Number);
   if(Num)
     {
     IRQ=Stat.Data=malloc(Num * sizeof(AcpiIRQ) );
     Stat.Command = ACPI_STATISTICS_GETIRQ;
     rc=AcpiGetStatistics(&Hdl,&Stat);
     if(rc)
       {
       printf("Error open ACPI API rc=%d\n",rc);
       exit(1);
       }
     for(i = 0; i < Stat.Number; i++)
        {
        printf("IRQ%2.2d called %lld\n",i,IRQ[i].Count);
        }
     }
   rc=AcpiEndApi(&Hdl);
   exit(0);

}
