/***************************************************************************
 *      Created 2005  eCo Software                                         *
 *                                                                         *
 *      DISCLAIMER OF WARRANTIES.  The following [enclosed] code is        *
 *      sample code created by eCo Software. This sample code is not part  *
 *      of any standard or eCo Software product and is provided to you     *
 *      solely for the purpose of assisting you in the development of your *
 *      applications.  The code is provided "AS IS", without               *
 *      warranty of any kind. eCo Software shall not be liable for any     *
 *      damages arising out of your use of the sample code, even if they   *
 *      have been advised of the possibility of such damages.              *
 *-------------------------------------------------------------------------*/
#define INCL_DOSPROCESS
#include <os2.h>
#include "acpi.h"
#include "acpiapi.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"

PROCESSOR Processor[64];

void AcpiFindProcessor(void);

void  main(int argc,char **argv)
{
 APIRET rc;
 ACPI_API_HANDLE Hdl;
 UINT32 Perfomance,CpuId,i;
 UINT8  Width;
 
   rc=AcpiStartApi(&Hdl);
   if(rc)
     {
     printf("Error open ACPI API rc=%d\n",rc);
     exit(1);
     }
   if( argc > 3 )
     {
     CpuId=atoi(argv[1]);
     Perfomance=atoi(argv[2]);
     i=atoi(argv[3]);
     printf("Set State %d\n",i);
     rc=AcpiSetCState(&Hdl,CpuId,Perfomance,i);
     if(rc)
        printf("State %d set error %x\n",i,rc);
     else
        printf("State %d set succesfull\n",i);
     exit(0);
     }
   if( argc < 2 )
     {
     AcpiFindProcessor();                                         // Finding processors
     for( i=0; i < 64; i++)
        {
        if(Processor[i].PblkAddress == 0) continue;
        rc=AcpiGetTrottling(&Hdl,i,&Perfomance,&Width);
        if(rc)
          {
          printf("CPU%d Error get throttling rc=%d\n",i,rc);
          exit(1);
          }
        if(Width)
           printf("Min set is %d\n",(100 >> Width) + 1);
        if(Perfomance)
           printf("CPU%d Perfomance=%d %% \n",i,Perfomance);
        else
           printf("CPU%d throttling is disabled\n",i);
        }
     rc=AcpiEndApi(&Hdl);
     exit(0);
     }
   else if ( argc < 3 )
           {
           printf("Usage: GetSet [ProcID Perfomance]\n Pefomance 0...100 %%\n");
           exit(0);
           }
   CpuId=atoi(argv[1]);
   Perfomance=atoi(argv[2]);
   rc=AcpiSetTrottling(&Hdl,CpuId,Perfomance);
   if(rc == 0)
     printf("Trottling to %d set succesfull\n",CpuId);
   else
     printf("Trottling set error rc=%d\n",rc);
   rc=AcpiEndApi(&Hdl);
   exit(rc);
}
ACPI_STATUS GetProcessor(ACPI_HANDLE ObjHandle,
			    UINT32 NestingLevel,
			    void *Context,
			    void **ReturnValue)
{
 ACPI_STATUS       Status;
 ACPI_BUFFER       Buffer;
 ACPI_BUFFER       Results;
 ACPI_OBJECT       Obj;
 char              DevName[5];
 UINT32            i;

  Buffer.Length = 5;
  Buffer.Pointer = DevName;
  AcpiGetName(ObjHandle, ACPI_SINGLE_NAME, &Buffer);
  printf("Processor [");
  for(i=0; i < 4; i++)
      printf("%c",DevName[i]);
  printf("]\n");
  Results.Length  = sizeof(Obj);
  Results.Pointer = &Obj;
  Status=AcpiEvaluateObject(ObjHandle,NULL,NULL,&Results);
  printf("------------------------------------\n");
  if( Status != AE_OK )                   return Status;
  if( Obj.Type != ACPI_TYPE_PROCESSOR )   return Status;
         printf(" ProcId:     0x%x\n",Obj.Processor.ProcId);
         printf(" P_BLK:      0x%x\n",Obj.Processor.PblkAddress);
         printf(" P_BLK len:  0x%x\n",Obj.Processor.PblkLength);
  if(Obj.Processor.PblkAddress)
    printf("Possible for throttle setting\n");
  printf("------------------------------------\n");
  Processor[Obj.Processor.ProcId].PblkAddress=Obj.Processor.PblkAddress;
  Processor[Obj.Processor.ProcId].PblkLength =Obj.Processor.PblkLength;
  return Status;
}
void AcpiFindProcessor(void)
{
 ACPI_STATUS       Status;
 printf("Searching processors\n");
 Status=AcpiWalkNamespace(ACPI_TYPE_PROCESSOR, // All device
		            ACPI_ROOT_OBJECT,    // Start object
		            ACPI_UINT32_MAX,     // Max depth
		            GetProcessor,        // Callback
                          NULL, NULL);         // Callback param and poitner to return value

} 
